unit USBTxThread;

interface

uses
  Classes, windows,D2XXUnit;


type
  TUSBTxThread = class(TThread)
  private
    { Private 錾 }
    FMode: byte;
    FHandle: DWord;
    Fsl: TStrings;
    Fs: string;
    Fcounter: integer;
    FFT_Out_Buffer: array[0..$10000-1] of byte;
    FWrite_Result: integer;

    Fok: boolean;
    sent:boolean;

    FPos:integer;

    procedure ini;
    procedure fin;
    procedure pos;

//    procedure sendChar;
  protected
    procedure Execute; override;

  public
    finished: boolean;
    constructor Create(Handle: DWord; mode:byte; sl:TStrings); virtual;

  end;



implementation


uses main;

{ TxThread }
constructor TUSBTxThread.Create(Handle:DWord; mode:byte; sl:TStrings);
begin
  FMode:=mode;
  FHandle := Handle;
  sent := false;
  FSl:=TStringList.Create;
  FSl.Assign(sl);
  Fok:=false;

  finished:=false;

  inherited Create(False);
  FreeOnTerminate := True;
end;



//procedure TUSBTxThread.sendChar;
//begin

//  while FCounter<=length(FS) do begin
//    FFT_Out_Buffer[FCounter-1]:=Byte(Fs[FCounter]);
//    inc(FCounter);
//  end;
//  FFT_Out_Buffer[FCounter-1]:=Byte(#13);
//  FT_Write(FHandle,@FFT_Out_Buffer,length(FS)+1,@FWrite_Result);


//  if FCounter<=Length(FS) then begin
//    FFT_Out_Buffer[0]:=Byte(Fs[FCounter]);
//    FT_Write(FHandle,@FFT_Out_Buffer,1,@FWrite_Result);
//    inc(FCounter);
//  end
//  else begin

//    MainForm.TerminalMemo.Lines.Add('*'+fs);

//    FFT_Out_Buffer[0]:=Byte(#13);
//    FT_Write(FHandle,@FFT_Out_Buffer,1,@FWrite_Result);

//    sent:=true;

//end;


procedure TUSBTxThread.ini;
begin
  MainForm.transferButton.Enabled:=false;
  MainForm.runStopButton.Enabled:=false;
  MainForm.clearButton.Enabled:=false;
  MainForm.VariableEdit.Enabled:=false;
  MainForm.VariableListView.Enabled:=false;
  MainForm.enableArrayCheckBox.Enabled:=false;

  MainForm.USBTxProgressBar.Left:=MainForm.FidPaintBox.Width div 2
                      -MainForm.USBTxProgressBar.Width div 2;
  MainForm.USBTxProgressBar.Top:=MainForm.FIDPaintBox.Height div 2
                      -MainForm.USBTxProgressBar.Height div 2;


  MainForm.USBTxProgressBar.Min:=0;
  MainForm.USBTxProgressBar.Max:=FSL.Count;
  MainForm.USBTxProgressBar.visible:=true;

  FOK:=true;
end;


procedure TUSBTxThread.fin;
begin
 // MainForm.transferButton.Enabled:=true;
  MainForm.runStopButton.Enabled:=true;
  MainForm.clearButton.Enabled:=true;
  MainForm.VariableEdit.Enabled:=true;
  MainForm.VariableListView.Enabled:=true;
  MainForm.enableArrayCheckBox.Enabled:=true;
  MainForm.USBTxProgressBar.visible:=false;

  FOK:=true;
end;


procedure TUSBTxThread.pos;
begin
  MainForm.USBTxProgressBar.Position:=FPos;
end;

procedure TUSBTxThread.Execute;
var i:integer;
begin
  { ToDo : XbhƂĎsR[hɋLq }
  FOK:=false;
  while ((not terminated) and (not FOK)) do Synchronize(ini);

//  MainForm.transferButton.Enabled:=false;
//  MainForm.runStopButton.Enabled:=false;
//  MainForm.clearButton.Enabled:=false;
//  MainForm.VariableEdit.Enabled:=false;
//  MainForm.VariableListView.Enabled:=false;
//  MainForm.enableArrayCheckBox.Enabled:=false;

  USBRx.Mode:=FMode;

  USBTxBusy:=true;

  sleep(1);
  FFT_Out_Buffer[0]:=Byte(#13);
  FT_Write(FHandle,@FFT_Out_Buffer,1,@FWrite_Result);
  sleep(1);

  for i:=0 to Fsl.Count-1 do begin

    Fs:=Fsl[i];
    sent:=false;
    FCounter:=1;

    while FCounter<=length(FS) do begin
      FFT_Out_Buffer[FCounter-1]:=Byte(Fs[FCounter]);
      inc(FCounter);
    end;
    FFT_Out_Buffer[FCounter-1]:=Byte(#13);
    FT_Write(FHandle,@FFT_Out_Buffer,length(FS)+1,@FWrite_Result);

    FPos:=i;
    synchronize(pos);
    //MainForm.USBTxProgressBar.Position:=i;
    // MainForm.TerminalMemo.Lines.Add('*'+fs);

  end; // i

  FOK:=false;
  while ((not terminated) and (not FOK)) do Synchronize(fin);

 // MainForm.transferButton.Enabled:=true;
 // MainForm.runStopButton.Enabled:=true;
 // MainForm.clearButton.Enabled:=true;
 // MainForm.VariableEdit.Enabled:=true;
 // MainForm.VariableListView.Enabled:=true;
 // MainForm.enableArrayCheckBox.Enabled:=true;

  USBRx.Mode:=1;

  Fsl.Free;

  usbTxBusy:=false;

  finished:=true;
end;

end.

