unit TxThread;

interface

uses
  Classes, windows, rs232c;


type
  TTxThread = class(TThread)
  private
    { Private 錾 }
    Frs232c: Trs232c;
    Fsl: TStrings;
    Fs: string;
    Fcounter: integer;

    procedure sendChar;
  protected
    procedure Execute; override;

  public
    finished: boolean;
    constructor Create(rs232c: Trs232c; sl:TStrings); virtual;

  end;



implementation


uses main;

{ TxThread }
constructor TTxThread.Create(rs232c:Trs232c; sl:TStrings);
begin
  Frs232c := rs232c;
  finished := false;
  FSl:=TStringList.Create;
  FSl.Assign(sl);

  inherited Create(False);
  FreeOnTerminate := True;
end;


procedure TTxThread.sendChar;
begin
  if FCounter<=Length(FS) then begin
    Frs232c.rswritechar(Fs[FCounter]);
    inc(FCounter);
  end  
  else finished:=true;
end;



procedure TTxThread.Execute;
var i:integer;
begin
  { ToDo : XbhƂĎsR[hɋLq }
  MainForm.Button1.Enabled:=false;

  sleep(1);
  Frs232c.rswritechar(#13);
  sleep(1);

  for i:=0 to Fsl.Count-1 do begin

    Fs:=Fsl[i];
    finished:=false;
    FCounter:=1;

    while ((not terminated) and (not finished)) do begin
      Synchronize(sendChar);
    end; //while

    sleep(10);
    if MainForm.TerminalMemo.Lines[i]='' then
      MainForm.TerminalMemo.Lines[i]:='*'+fs+#13
    else MainForm.TerminalMemo.Lines[i]:=MainForm.TerminalMemo.Lines[i]+fs;
    FRs232c.rswritechar(#13);
    sleep(10);


  end; // i

  sleep(1);
  FRs232c.rswritechar(#13);
  sleep(1);

  MainForm.Button1.Enabled:=true;

  Fsl.Free;
end;

end.
